const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const coin_code_redemptions = sequelize.define(
    'coin_code_redemptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

redeemed_at: {
        type: DataTypes.DATE,
      
      

      },

amount_doodlecoins: {
        type: DataTypes.INTEGER,
      
      

      },

status_message: {
        type: DataTypes.TEXT,
      
      

      },

successful: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  coin_code_redemptions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.coin_code_redemptions.belongsTo(db.coin_codes, {
      as: 'coin_code',
      foreignKey: {
        name: 'coin_codeId',
      },
      constraints: false,
    });

    db.coin_code_redemptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.coin_code_redemptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.coin_code_redemptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return coin_code_redemptions;
};


